#!/usr/bin/perl
require "bbconfig";

$READ_DB= $USERPATH . "read";		
 					#Find the first notice file.

unless (-e $USERPATH) {			#First time user with no user directory?
	mkdir ($USERPATH, 0740) ||
		PrintError("Couldn't create $USERPATH. <p>");	
}

unless (-e $READ_DB) {			#first time user w/ no file?

	open (TOUCH, ">".$READ_DB) ||
		PrintError("Couldn't create $READ_DB. <p>");
	close (TOUCH);
}					

opendir(POSTS, $POSTPATH) ||
        PrintError("Couldn't opendir() $POSTPATH<br>");

@perm = readdir(POSTS);	
$null=shift(@perm);
$null=shift(@perm);

closedir(POSTS);


open (USERFILE, $READ_DB) ||
	PrintError("Couldn't open $ABSOLUTE_DB_PATH. <p>");

@temp=<USERFILE>;
foreach (@temp) {
	chomp($_);
}
close (USERFILE);

local(%check);
grep($check{$_}++,@temp); 
@unread = grep(!$check{$_},@perm);	# finds difference between database of all

					# posts and what the user has read
$CONSIDER = $unread[0];

if ($CONSIDER) {
	&found_unread;
}
else {
	&no_unread;
}

#-------------------------------------------------------------------
sub found_unread {

	$path_to_post= $POSTPATH . $CONSIDER;


	open (USER_HANDLE, ">>". $READ_DB) ||	# update reader's file
		PrintError("Couldn't open $ABSOLUTE_DB_PATH. <p>");

	chomp($CONSIDER);
	print USER_HANDLE $CONSIDER, "\n";
	close (USER_HANDLE);

	&output_article;

	exit 0; 
}

#---------------------------------------------------------------
sub output_article {

	open (FILE_HANDLE, $path_to_post) || PrintError("Couldn't open $path_to_post. <p>");

	$POSTER = <FILE_HANDLE>;
	chomp $POSTER;

	#--skipnames check--#
	$skipnames = $OPTIONSPATH. "bbskipnames";
	if ( -e $skipnames) {
		open(IN, $skipnames) ||  PrintError("Couldn't open $skipnames. <p>");
		@skipnames=<IN>;
		close(IN);
	        if (grep /$POSTER/, @skipnames) {
			print "Content-type: text/html\n\n";
	                print "<HTML><HEAD>";
	                print '<meta HTTP-EQUIV="Refresh" ';
	                print "content=\"0;URL=$RELCGI/unread.cgi/$cat\">";
	                print '</HEAD><BODY bgcolor="#000000"></BODY></HTML>';
			exit 0;
	        };
	}
	#--end skipnames check--#	

	$threadline=<FILE_HANDLE>;
	@tinfo=split /:/,$threadline;  # check for replies to this article 
			
	$ARTICLE_NUM = $tinfo[0];
	$replies= (@tinfo-1);	#yeah, that's right. :)
	chomp($ARTICLE_NUM);

	$SUBJECT = <FILE_HANDLE>;
	chomp($SUBJECT);

	@TEXT = <FILE_HANDLE>;
	close (FILE_HANDLE);

	&GetAddress;    #find the user's address

	$MAILTO = $names{$POSTER};

	&PrintArticle; 		#located in bbconfig

	&PrintBase;		#located in bbconfig
}

#-----------------------------------------------------------
sub no_unread {

	print "Content-type: text/html\n\n";
	print "<HTML> <HEAD>\n";
	print "<meta HTTP-EQUIV=Refresh Content=\"1; URL=$RELCGI/markallread.pl/$cat/\">"; 
	print "\n<TITLE>BB $cat</TITLE> </HEAD>"; 
	print "\n<BODY bgcolor=000000 text=FFFFFF link=FFFFFF vlink=FFFFFF>
		\n";
	print "<TABLE BORDER=1 width=80%> <TR>\n";

	print "<TD align=center><b>Num</b></TD> <TD
		align=center><b>Username</b></TD>\n";
	print "<TD align=center><b>Category</b></TD> <TD
		align=center><b>Posted</b></TD>\n";
	print "<TD align=center><b>Expires</b></TD> <TD
		align=center><b>Page</b></TD>\n";
	print "</TR><TR><TD colspan=1> </TD> \n";
	print "<TD colspan=1>&nbsp;</TD> <TD align=center> $CAT</TD>
		\n";
	print "<TD align=center> / / </TD> <TD align=center>
		Never(Yet)</TD> \n";
	print "<TD align=center> &nbsp;</TD> </TR>";

	print "<TR> <TD colspan=6> No Unread Notices Found </TD> </TR>";
	print "</TABLE> <P><P>\n";

	print "</BODY> </HTML>";

	exit 0;
}


