#!/usr/bin/perl

$NEEDNOINFO=1;    # we don't need path info here.  
		  # keep bbconfig from erroring out.
require "bbconfig";

print "Content-type: text/html\n\n";
print '<html><head>', "\n";
print '<meta content="generator" keyword="vaxbb">', "\n";  
print "<meta HTTP-EQUIV=\"Refresh\" content=\"7; URL=$HTINDEX\">\n";
print '<title>C2K -- BBSTATUS</title></head>', "\n";  
print '<body bgcolor=000000 text=ffffff link=ffffff vlink=ffffff>', "\n";  
print '<center><h4>BBSTATUS</h4><p><p><p>', "\n";  

unless (-e $USERDIR . $USER) {		# check for userdir
	mkdir ($USERDIR . $USER, 0740) ||	# (could be first use)
		PrintError("Couldn't mkdir ". $USERDIR . $USER."<p>\n"); 
}
$i=0;
while ($categories[$i]) {
	 chomp($categories[$i]);
	$DBPATH = $BBCGI . '/posts/' . $categories[$i] .'/';
	$POSTPATH=$DBPATH . 'postfiles/';
	$userfile = $USERDIR . $USER . '/' . $categories[$i] . '/read';
	$latestfile=$DBPATH . "/latest_notice";	
	$catdir=$USERDIR . $USER . '/' . $categories[$i];
	unless (-e $catdir) {
		unless (mkdir ($catdir, 0740)) {
			PrintError("Couldn't mkdir $catdir!<p>");
		}
	}
	
	unless (-e $userfile) { 
		open (TOUCH, ">".$userfile) || PrintError("couldn't touch $userfile!");
		close(TOUCH);
	}

	unless (open (USER_HANDLE, $userfile)) {
                PrintError("Couldn't open $userfile!!!<p>\n");
	}

	@userfile = <USER_HANDLE>; $userlines = @userfile;
	close(USER_HANDLE);
		
	#commented 3/20/01 using glob instead of db
	#unless (open (DB_HANDLE, $dbfile)) {
        #        PrintError("Couldn't open $dbfile.<p>");
	#}
	#
	#@dbfile = <DB_HANDLE>; $dblines = @dbfile;
	#close(DB_HANDLE);

	opendir (DB, $POSTPATH) || 
		PrintError("Couldn't opendir() $POSTPATH<br>");

	@dbfile=readdir(DB);
	$dblines = @dbfile - 2;	#there will always be . and ..
	close(DB);
	
	unless (open (LATEST_HANDLE, $latestfile)) {
                PrintError("Couldn't open $latestfile.<p>");
	}

	$numbers[$i] = <LATEST_HANDLE>;
	$diffs[$i] = $dblines - $userlines;
	close(LATEST_HANDLE);
	$i++;
}

$i=0;

while ($categories[$i]) {
	$total = $numbers[$i] -1;
	print "<br><a href=\"$RELCGI/htmls.pl/$categories[$i]/bbmain\">".
	$categories[$i], '</a>: ', $total, "\n";
	if ($diffs[$i]<0) {
		$diffs[$i] = 0;
	}
	print "for which you have ". $diffs[$i] . " unread.";
	$i++;
}

print "<p><p><a href=\"$HTINDEX\">Exit</a>\n";
print "</center></BODY></HTML>";
exit 0;
