#!/usr/bin/perl
require "cgi-lib.pl";
require "bbconfig";

#Who's the user here?

$USER=$ENV{'REMOTE_USER'};

# Format post file names: year, month, day, hour, min, sec (YYYYMDHMS)
# This is separate from the notice number, which is displayed on the
# bb.

$POSTFILE = `date +%Y%m%d%H%M%S`;

				#Start printing the output.

print "Content-type: text/html\n\n";
print "<html>\n<head>\n";

&ReadParse(*values);

			#complain if required values are missing.

if (! $values{"text"} ) {
	print "<title> Please fill out all required fields</title>";
	print "</head>\n";
	print "<h1> Please fill out the required fields!</h1>";
	print "You've gotta have some text. Nobody wants to see empty posts."; 
	print "</body></html>\n";
	exit 0;
}

# the latest_notice file keeps track of the external
#	notice number.

$NOTICE_NUMBER_FILE = $DBPATH . 'latest_notice';

				#get the notice number & increment.

open (NUMBER_HANDLE, $NOTICE_NUMBER_FILE) || PrintError("couldn't open $NOTICE_NUMBER_FILE");
$article_number = <NUMBER_HANDLE>;
close (NUMBER_HANDLE); 

$next_number = ($article_number + 1);

open (INC_NUM_HANDLE, ">".$NOTICE_NUMBER_FILE) || PrintError("couldn't open $NOTICE_NUMBER_FILE");
print INC_NUM_HANDLE $next_number;
close (INC_NUM_HANDLE);

$ABSOLUTE_FILE_PATH = $POSTPATH . $POSTFILE;

open(OUT, ">". $ABSOLUTE_FILE_PATH) || PrintError("couldn't open $ABSOLUTE_FILE_PATH.<p>");

				#Write the post file.
print OUT $USER, "\n";
print OUT $article_number, "\n";

#print OUT $values{"subject"}, "\n";

$subject = $values{"subject"};
$subject =~ (s/>/&gt;/g);		#escape out all < and > 's.   
$subject =~ (s/</&lt;/g);
$subject =~ (s/"/&quot;/g);
print OUT $subject, "\n";

$text = $values{"text"};
$text =~ (s/>/&gt;/g);   
$text =~ (s/</&lt;/g);
$text =~ (s/"/&quot;/g);
print OUT $text;  

close(OUT);

if ($values{"replyto"}) {	# if replyto exists, article is a reply

	&UpdateThreadInfo;	# thread info needs to be updated here
}

				#Give the user some feedback

print "<HTML><HEAD><TITLE> Article ", $article_number;
print " Posted.</TITLE>\n";  
print "<meta HTTP-EQUIV=Refresh content=\"2; URL=$RELCGI/htmls.pl/$cat/bbmain/\">\n";
print "<BODY bgcolor=000000 text=FFFFFF link=FFFFFF vlink=FFFFFF>";
print "Article ", $article_number, " Posted.\n";  
print "</body> </html>\n";
exit 0;

#----------

sub UpdateThreadInfo {

	$filename = $values{"replyto"};
	&TestInput($filename);
	$replyto=$BBCGI."/posts/".$cat."/postfiles/".$filename;

	open(REP_IN, $replyto) ||
		PrintError ("Couldn't open $replyto. <p>" .
		"This is to update thread info for the replied-to article.<br>");

	$head1 = <REP_IN>;
	$head2 = <REP_IN>;
	@rest = <REP_IN>;

	close(REP_IN);

	open(REP_OUT, ">". $replyto) ||
		PrintError( "Couldn't modify $replyto.<p> 
			This is to add the threading information.<br>\n");

	print REP_OUT $head1;
	chomp($head2);
	print REP_OUT $head2 . ":$article_number\n";  # this is the number of the
	print REP_OUT @rest;			      # repling post.
	close(REP_OUT);
}
# end sub UpdateThreadInfo
